-- BuffCheck_Settings.lua
-- by Mithrandir1210

--[[
	TO DO:
		- Consolidate checkbuttons(for loop?)
			- GetChecked and SetChecked functions
		- Find out how to mass-create checkbuttons in lua
]]

-- GENERAL INFORMATION --======================================================

-- Load addon-local variables table
local BuffCheck_Name, bc = ...
	-- BuffCheck_Name = "BuffCheck"
	-- BuffCheck = {}

bc.Description = {
	Title = GetAddOnMetadata(BuffCheck_Name, "Title"),
	Version = GetAddOnMetadata(BuffCheck_Name, "Version"),
	Author = GetAddOnMetadata(BuffCheck_Name, "Author")
}

-- DEFAULT SETTINGS --=========================================================

-- COLOR PREFIXES
bc.Colors = {
	Red = "|cFFFF0000",
	Blue = "|cFF0000FF",
	Green = "|cFF008000",
	Yellow = "|cFFFFFF00",
	Brown = "|cFF663300",
	Gray = "|cFF808080",
	White = "|cFFFFFFFF",
	Black = "|cFF000000",
	Aquablue = "|cFF00B8E6"
}

bc.Defaults = {
	FontColor = bc.Colors.Aquablue,
	DisableBuffOutput = false,
	AnnounceMissing = true,
	CheckAfterReadycheck = false,
	DisplaySettingsOnLoad = false,

	-- (4)
	BuffEnabled = {
		Food = true,
		GreaterFlasks = true,
		Stats = true,
		Stam = true,
		Ap = true,
		Sp = true,
		Mastery = true,
		Haste = true,
		Crit = true,
		Multi = true,
		Vers = true,
		AugmentRune = true
	}
}

bc.NumPlayers = nil

-- INITIALIZATION --===========================================================

-- CREATE FRAMES --
bc.InitEventFrame = CreateFrame("Frame")
bc.MainEventFrame = CreateFrame("Frame")

-- REGISTER EVENTS --
bc.InitEventFrame:RegisterEvent("ADDON_LOADED")
bc.MainEventFrame:RegisterEvent("READY_CHECK_FINISHED")

-- POPULATE INTERFACE OPTIONS --===============================================

-- Add entry to interface options
bc.panel = CreateFrame ("Frame", "bc_Panel", UIParent);
bc.panel.name = "Buff Check";
InterfaceOptions_AddCategory(bc.panel);

-- Create main title (header)
bc.SettingsTitle = bc.panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
bc.SettingsTitle:SetPoint("TOPLEFT", 10, -15)
bc.SettingsTitle:SetText("Buff Check")

-- Create subtitle
bc.SettingsTitle = bc.panel:CreateFontString(nil, "ARTWORK", "GameFontNormal")
bc.SettingsTitle:SetPoint("TOPLEFT", 10, -50)
bc.SettingsTitle:SetText("General Options")

-- Create checkbuttons and their labels

-- 1. Disable output?
bc.btnDisableBuffOutput = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnDisableBuffOutput:SetPoint("TOPLEFT", 20, -70)
bc.btnDisableBuffOutput_Text = bc.btnDisableBuffOutput:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnDisableBuffOutput_Text:SetPoint("LEFT", bc.btnDisableBuffOutput, "RIGHT", 0, -1)
bc.btnDisableBuffOutput_Text:SetText("Disable buff output")

-- 2. Announce to raid?
bc.btnAnnounce = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnAnnounce:SetPoint("TOPLEFT", 20, -100)
bc.btnAnnounce_Text = bc.btnAnnounce:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnAnnounce_Text:SetPoint("LEFT", bc.btnAnnounce, "RIGHT", 0, -1)
bc.btnAnnounce_Text:SetText("Announce missing buffs to chat")

-- 3. Check after readycheck?
bc.btnReadycheck = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnReadycheck:SetPoint("TOPLEFT", 20, -130)
bc.btnReadycheck_Text = bc.btnReadycheck:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnReadycheck_Text:SetPoint("LEFT", bc.btnReadycheck, "RIGHT", 0, -1)
bc.btnReadycheck_Text:SetText("Check for buffs after readycheck")

-- 4. Display settings on load?
bc.btnDisplaySettingsOnLoad = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnDisplaySettingsOnLoad:SetPoint("TOPLEFT", 20, -160)
bc.btnDisplaySettingsOnLoad_Text = bc.btnDisplaySettingsOnLoad:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnDisplaySettingsOnLoad_Text:SetPoint("LEFT", bc.btnDisplaySettingsOnLoad, "RIGHT", 0, -1)
bc.btnDisplaySettingsOnLoad_Text:SetText("Display settings on load")

-- 5. ENABLE/DISABLE BUFFS?

-- Create subtitle
bc.SettingsTitle = bc.panel:CreateFontString(nil, "ARTWORK", "GameFontNormal")
bc.SettingsTitle:SetPoint("TOPRIGHT", -10, -50)
bc.SettingsTitle:SetText("Enabled Buffs")

-- TESTING THIS! (create multiple checkbuttons in loop)
-- Creates all checkbuttons and labels for enabled buffs
-- local y = 0
-- for i=1, #bc.Buffs.Index do
	-- local CheckButton_Buffs, CheckButton_Buffs_Text
	-- CheckButton_Buffs = CreateFrame("CheckButton", "BuffCheck_CBtnBuff"..i, bc.panel, "InterfaceOptionsCheckButtonTemplate")
	-- CheckButton_Buffs:SetPoint("TOPRIGHT", -20, (-70-y))
	-- CheckButton_Buffs_Text = CheckButton_Buffs:CreateFontString("BuffCheck_CBtnBuff_Text"..i, "ARTWORK", "GameFontHighlight")
	-- CheckButton_Buffs_Text:SetPoint("TOPRIGHT", CheckButton_Buffs, "LEFT", 0, 5)
	
	-- y = y + 30
-- end
-- BuffCheck_CBtnBuff_Text1:SetText("Food")

-- Food
bc.btnFood = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnFood:SetPoint("TOPRIGHT", -20, -70)
bc.btnFood_Text = bc.btnFood:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnFood_Text:SetPoint("TOPRIGHT", bc.btnFood, "LEFT", 0, 5)
bc.btnFood_Text:SetText("Food")

-- GreaterFlasks
bc.btnGreaterFlasks = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnGreaterFlasks:SetPoint("TOPRIGHT", -20, -100)
bc.btnGreaterFlasks_Text = bc.btnGreaterFlasks:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnGreaterFlasks_Text:SetPoint("TOPRIGHT", bc.btnGreaterFlasks, "LEFT", 0, 5)
bc.btnGreaterFlasks_Text:SetText("Greater Flask")

-- Stats
bc.btnStats = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnStats:SetPoint("TOPRIGHT", -20, -130)
bc.btnStats_Text = bc.btnStats:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnStats_Text:SetPoint("TOPRIGHT", bc.btnStats, "LEFT", 0, 5)
bc.btnStats_Text:SetText("Stats")

-- Stam
bc.btnStam = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnStam:SetPoint("TOPRIGHT", -20, -160)
bc.btnStam_Text = bc.btnStam:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnStam_Text:SetPoint("TOPRIGHT", bc.btnStam, "LEFT", 0, 5)
bc.btnStam_Text:SetText("Stamina")

-- Ap
bc.btnAp = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnAp:SetPoint("TOPRIGHT", -20, -190)
bc.btnAp_Text = bc.btnAp:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnAp_Text:SetPoint("TOPRIGHT", bc.btnAp, "LEFT", 0, 5)
bc.btnAp_Text:SetText("Attack Power")

-- Sp
bc.btnSp = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnSp:SetPoint("TOPRIGHT", -20, -220)
bc.btnSp_Text = bc.btnSp:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnSp_Text:SetPoint("TOPRIGHT", bc.btnSp, "LEFT", 0, 5)
bc.btnSp_Text:SetText("Spell Power")

-- Mastery
bc.btnMastery = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnMastery:SetPoint("TOPRIGHT", -20, -250)
bc.btnMastery_Text = bc.btnMastery:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnMastery_Text:SetPoint("TOPRIGHT", bc.btnMastery, "LEFT", 0, 5)
bc.btnMastery_Text:SetText("Mastery")

-- Haste
bc.btnHaste = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnHaste:SetPoint("TOPRIGHT", -20, -280)
bc.btnHaste_Text = bc.btnHaste:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnHaste_Text:SetPoint("TOPRIGHT", bc.btnHaste, "LEFT", 0, 5)
bc.btnHaste_Text:SetText("Haste")

-- Crit
bc.btnCrit = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnCrit:SetPoint("TOPRIGHT", -20, -310)
bc.btnCrit_Text = bc.btnCrit:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnCrit_Text:SetPoint("TOPRIGHT", bc.btnCrit, "LEFT", 0, 5)
bc.btnCrit_Text:SetText("Critical Strike")

-- Multi
bc.btnMulti = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnMulti:SetPoint("TOPRIGHT", -20, -340)
bc.btnMulti_Text = bc.btnMulti:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnMulti_Text:SetPoint("TOPRIGHT", bc.btnMulti, "LEFT", 0, 5)
bc.btnMulti_Text:SetText("Multistrike")

-- Vers
bc.btnVers = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnVers:SetPoint("TOPRIGHT", -20, -370)
bc.btnVers_Text = bc.btnVers:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnVers_Text:SetPoint("TOPRIGHT", bc.btnVers, "LEFT", 0, 5)
bc.btnVers_Text:SetText("Versatility")

-- AugmentRune
bc.btnRune = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnRune:SetPoint("TOPRIGHT", -20, -400)
bc.btnRune_Text = bc.btnRune:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnRune_Text:SetPoint("TOPRIGHT", bc.btnRune, "LEFT", 0, 5)
bc.btnRune_Text:SetText("Augment Rune")

-- Enable All Buffs
bc.btnEnableAllBuffs = CreateFrame ("CheckButton", nil, bc.panel, "InterfaceOptionsCheckButtonTemplate")
bc.btnEnableAllBuffs:SetPoint("TOPRIGHT", -20, -430)
bc.btnEnableAllBuffs_Text = bc.btnEnableAllBuffs:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
bc.btnEnableAllBuffs_Text:SetPoint("TOPRIGHT", bc.btnEnableAllBuffs, "LEFT", 0, 5)
bc.btnEnableAllBuffs_Text:SetText("Enable All?")

-- FUNCTIONS --================================================================

-------------------------------------------------------------------------------
-- Set state of ALL Enabled Buffs Checkbuttons to specified argument.
-- If 'Status' is a boolean, set all to the same
-- Otherwise, set to values of BuffCheck_ActiveSettings.BuffEnabled
-------------------------------------------------------------------------------
bc.SetAllBuffCheckbuttons = function (Status)
	if type(Status) == "boolean" then 
		bc.btnFood:SetChecked(Status)
		bc.btnGreaterFlasks:SetChecked(Status)
		bc.btnStats:SetChecked(Status)
		bc.btnStam:SetChecked(Status)
		bc.btnAp:SetChecked(Status)
		bc.btnSp:SetChecked(Status)
		bc.btnMastery:SetChecked(Status)
		bc.btnHaste:SetChecked(Status)
		bc.btnCrit:SetChecked(Status)
		bc.btnMulti:SetChecked(Status)
		bc.btnVers:SetChecked(Status)
		bc.btnRune:SetChecked(Status)
	else
		bc.btnFood:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Food)
		bc.btnGreaterFlasks:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.GreaterFlasks)
		bc.btnStats:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Stats)
		bc.btnStam:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Stam)
		bc.btnAp:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Ap)
		bc.btnSp:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Sp)
		bc.btnMastery:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Mastery)
		bc.btnHaste:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Haste)
		bc.btnCrit:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Crit)
		bc.btnMulti:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Multi)
		bc.btnVers:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Vers)
		bc.btnRune:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.AugmentRune)
	end
	
end
-------------------------------------------------------------------------------
-- Print the current general settings to the console (void).
-------------------------------------------------------------------------------
bc.ViewSettings = function()

	-- 1. Disable output
	if BuffCheck_ActiveSettings.DisableBuffOutput then
		bc.Display("Disable buff output?: ".."Yes")
	else
		bc.Display("Disable buff output?: ".."No")
	end
	
	-- 2. Announce missing 
	if BuffCheck_ActiveSettings.AnnounceMissing then
		bc.Display("Announce to chat?: ".."Yes")
	else
		bc.Display("Announce to chat?: ".."No")
	end
	
	-- 3. Check after readycheck
	if BuffCheck_ActiveSettings.CheckAfterReadycheck then
		bc.Display("Check after readycheck?: ".."Yes")
	else
		bc.Display("Check after readycheck?: ".."No")
	end
	
end

-------------------------------------------------------------------------------
-- Reset settings to their defaults (void).
-------------------------------------------------------------------------------
bc.SetDefaults = function()
	
	-- Clear missing buffs tables
	bc.Buffs.Clear()
		
	-- Disable output
	BuffCheck_ActiveSettings.DisableBuffOutput = bc.Defaults.DisableBuffOutput
	bc.btnDisableBuffOutput:SetChecked(bc.Defaults.DisableBuffOutput)	
		
	-- Announce to group
	BuffCheck_ActiveSettings.AnnounceMissing = bc.Defaults.AnnounceMissing
	bc.btnAnnounce:SetChecked(bc.Defaults.AnnounceMissing)
	
	-- Check after readycheck
	BuffCheck_ActiveSettings.CheckAfterReadycheck = bc.Defaults.CheckAfterReadycheck
	bc.btnReadycheck:SetChecked(bc.Defaults.CheckAfterReadycheck)

	-- Display settings on load
	BuffCheck_ActiveSettings.DisplaySettingsOnLoad = bc.Defaults.DisplaySettingsOnLoad
	bc.btnDisplaySettingsOnLoad:SetChecked(bc.Defaults.DisplaySettingsOnLoad)
	
	-- ENABLED BUFFS --
	
	-- Set all to defaults
	for BuffName in pairs(BuffCheck_ActiveSettings.BuffEnabled) do
		BuffCheck_ActiveSettings.BuffEnabled[BuffName] = bc.Defaults.BuffEnabled[BuffName]
	end
	
	-- Update checkbuttons
	-- bc.btnFood:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Food)
	-- bc.btnGreaterFlasks:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.GreaterFlasks)
	-- bc.btnStats:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Stats)
	-- bc.btnStam:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Stam)
	-- bc.btnAp:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Ap)
	-- bc.btnSp:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Sp)
	-- bc.btnMastery:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Mastery)
	-- bc.btnHaste:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Haste)
	-- bc.btnCrit:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Crit)
	-- bc.btnMulti:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Multi)
	-- bc.btnVers:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Vers)
	-- bc.btnRune:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.AugmentRune)
	
	bc.SetAllBuffCheckbuttons()
	
	if bc.Buffs.NumEnabledBuffs() == #bc.Buffs.Index then
		bc.btnEnableAllBuffs:SetChecked(true)
	elseif bc.Buffs.NumEnabledBuffs() == 0 then
		bc.btnEnableAllBuffs:SetChecked(false)
	end
	
	bc.Display("Defaults set.")
	
end

-- EVENT HANDLERS --===========================================================

-------------------------------------------------------------------------------
-- Sets global defaults if none are specified in the settings.
-------------------------------------------------------------------------------
bc.InitEventFrame:SetScript("OnEvent", function(self, event, addon, ...)
	
	if event == "ADDON_LOADED" and addon == BuffCheck_Name then
		
		-- SAVED VARIABLE TABLE (*** is this necessary???)
		BuffCheck_ActiveSettings = BuffCheck_ActiveSettings or {} -- Used for settings/options
		
		-- Disable output?
		if BuffCheck_ActiveSettings.DisableBuffOutput == nil then
			-- Set active settings to defaults
			BuffCheck_ActiveSettings.DisableBuffOutput = bc.Defaults.DisableBuffOutput
			bc.btnReadycheck:SetChecked(bc.Defaults.DisableBuffOutput)
		end
		-- Set state of checkbutton within interface options
		bc.btnDisableBuffOutput:SetChecked(BuffCheck_ActiveSettings.DisableBuffOutput)
		
		-- Announce to chat?
		if BuffCheck_ActiveSettings.AnnounceMissing == nil then
			-- Set saved settings to defaults
			BuffCheck_ActiveSettings.AnnounceMissing = bc.Defaults.AnnounceMissing
			bc.btnAnnounce:SetChecked(bc.Defaults.AnnounceMissing)
		end
		-- Set state of checkbutton within interface options
		bc.btnAnnounce:SetChecked(BuffCheck_ActiveSettings.AnnounceMissing)
		
		-- Check after readycheck?
		if BuffCheck_ActiveSettings.CheckAfterReadycheck == nil then
			-- Set active settings to defaults
			BuffCheck_ActiveSettings.CheckAfterReadycheck = bc.Defaults.CheckAfterReadycheck
			bc.btnReadycheck:SetChecked(bc.Defaults.CheckAfterReadycheck)
		end
		-- Set state of checkbutton within interface options
		bc.btnReadycheck:SetChecked(BuffCheck_ActiveSettings.CheckAfterReadycheck)
		
		-- Display settings on load?
		if BuffCheck_ActiveSettings.DisplaySettingsOnLoad == nil then
			-- Set active settings to defaults
			BuffCheck_ActiveSettings.DisplaySettingsOnLoad = bc.Defaults.DisplaySettingsOnLoad
			bc.btnDisplaySettingsOnLoad:SetChecked(bc.Defaults.DisplaySettingsOnLoad)
		end
		-- Set state of checkbutton within interface options
		bc.btnDisplaySettingsOnLoad:SetChecked(BuffCheck_ActiveSettings.DisplaySettingsOnLoad)

		-- *** Figure out how to consolidate the statements below (for loop???)
		
		-- Enabled and disabled buffs
		for BuffName in pairs(BuffCheck_ActiveSettings.BuffEnabled) do
			if BuffCheck_ActiveSettings.BuffEnabled[BuffName] == nil then
				BuffCheck_ActiveSettings.BuffEnabled[BuffName] = bc.Defaults.BuffEnabled[BuffName]
			end
		end
		-- Set state of checkbuttons within interface options
		-- bc.btnFood:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Food)
		-- bc.btnGreaterFlasks:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.GreaterFlasks)
		-- bc.btnStats:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Stats)
		-- bc.btnStam:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Stam)
		-- bc.btnAp:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Ap)
		-- bc.btnSp:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Sp)
		-- bc.btnMastery:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Mastery)
		-- bc.btnHaste:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Haste)
		-- bc.btnCrit:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Crit)
		-- bc.btnMulti:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Multi)
		-- bc.btnVers:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.Vers)
		-- bc.btnRune:SetChecked(BuffCheck_ActiveSettings.BuffEnabled.AugmentRune)
		
		bc.SetAllBuffCheckbuttons()
		
		if bc.Buffs.NumEnabledBuffs() == #bc.Buffs.Index then
			bc.btnEnableAllBuffs:SetChecked(true)
		elseif bc.Buffs.NumEnabledBuffs() == 0 then
			bc.btnEnableAllBuffs:SetChecked(false)
		end

		-- DISPLAY LOAD MESSAGE --
		bc.Display(bc.Description.Title.." v"..bc.Description.Version.." loaded.")
		
		if BuffCheck_ActiveSettings.DisplaySettingsOnLoad then
			bc.ViewSettings()
		end
	
	end -- if event and addon
	
end)

-- SCRIPTS FOR INTERFACE OPTIONS --============================================

-------------------------------------------------------------------------------
-- (1)
-- Changes the settings table to match the state of the 'disable buff output' checkbutton.
-------------------------------------------------------------------------------
bc.btnDisableBuffOutput:SetScript("OnClick", function ()
	
	if bc.btnDisableBuffOutput:GetChecked() then
		BuffCheck_ActiveSettings.DisableBuffOutput = true
	else
		BuffCheck_ActiveSettings.DisableBuffOutput = false
	end
	
end)

-------------------------------------------------------------------------------
-- (2)
-- Changes the settings table to match the state of the 'announce' checkbutton.
-------------------------------------------------------------------------------
bc.btnAnnounce:SetScript("OnClick", function ()
	
	if bc.btnAnnounce:GetChecked() then
		BuffCheck_ActiveSettings.AnnounceMissing = true
	else
		BuffCheck_ActiveSettings.AnnounceMissing = false
	end
	
end)

-------------------------------------------------------------------------------
-- (3)
-- Changes the settings table to match the state of the 'readycheck' checkbutton.
-------------------------------------------------------------------------------
bc.btnReadycheck:SetScript("OnClick", function ()
	
	if bc.btnReadycheck:GetChecked() then
		BuffCheck_ActiveSettings.CheckAfterReadycheck = true
	else
		BuffCheck_ActiveSettings.CheckAfterReadycheck = false
	end
	
end)

-------------------------------------------------------------------------------
-- (4)
-- Changes the settings table to match the state of the 'settings on load' checkbutton.
-------------------------------------------------------------------------------
bc.btnDisplaySettingsOnLoad:SetScript("OnClick", function ()
	
	if bc.btnDisplaySettingsOnLoad:GetChecked() then
		BuffCheck_ActiveSettings.DisplaySettingsOnLoad = true
	else
		BuffCheck_ActiveSettings.DisplaySettingsOnLoad = false
	end
	
end)

-- Food
bc.btnFood:SetScript("OnClick", function ()

	if bc.btnFood:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Food = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Food = false
	end

end)

-- GreaterFlasks
bc.btnGreaterFlasks:SetScript("OnClick", function ()

	if bc.btnGreaterFlasks:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.GreaterFlasks = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.GreaterFlasks = false
	end

end)

-- Stats
bc.btnStats:SetScript("OnClick", function ()

	if bc.btnStats:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Stats = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Stats = false
	end

end)

-- Stam
bc.btnStam:SetScript("OnClick", function ()

	if bc.btnStam:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Stam = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Stam = false
	end

end)

-- Ap
bc.btnAp:SetScript("OnClick", function ()

	if bc.btnAp:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Ap = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Ap = false
	end

end)

-- Sp
bc.btnSp:SetScript("OnClick", function ()

	if bc.btnSp:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Sp = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Sp = false
	end

end)

-- Mastery
bc.btnMastery:SetScript("OnClick", function ()

	if bc.btnMastery:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Mastery = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Mastery = false
	end

end)

-- Haste
bc.btnHaste:SetScript("OnClick", function ()

	if bc.btnHaste:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Haste = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Haste = false
	end

end)

-- Crit
bc.btnCrit:SetScript("OnClick", function ()

	if bc.btnCrit:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Crit = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Crit = false
	end

end)

-- Multi
bc.btnMulti:SetScript("OnClick", function ()

	if bc.btnMulti:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Multi = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Multi = false
	end

end)

-- Vers
bc.btnVers:SetScript("OnClick", function ()

	if bc.btnVers:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.Vers = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.Vers = false
	end

end)

-- AugmentRune
bc.btnRune:SetScript("OnClick", function ()

	if bc.btnRune:GetChecked() then
		BuffCheck_ActiveSettings.BuffEnabled.AugmentRune = true
	else
		BuffCheck_ActiveSettings.BuffEnabled.AugmentRune = false
	end

end)

-- Enable/Disable All
bc.btnEnableAllBuffs:SetScript("OnClick", function ()

	if bc.btnEnableAllBuffs:GetChecked() then
		bc.Buffs.SetBuffStatus("ALL", true)
		bc.SetAllBuffCheckbuttons(true)
		
	else
		bc.Buffs.SetBuffStatus("ALL", false)
		bc.SetAllBuffCheckbuttons(false)
	end

end)

-------------------------------------------------------------------------------
-- Enables functionality of 'Defaults' button in the interface options.
-------------------------------------------------------------------------------
bc.panel.default = function()
	
	bc.SetDefaults()
	
end